"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/index.ts
var src_exports = {};
__export(src_exports, {
  ApolloServerHighlightPlugin: () => ApolloServerHighlightPlugin,
  ApolloServerV3HighlightPlugin: () => ApolloServerV3HighlightPlugin
});
module.exports = __toCommonJS(src_exports);

// src/apollo.ts
var import_node = require("@highlight-run/node");
var ApolloServerHighlightPlugin = function(options) {
  return {
    requestDidStart(req) {
      return __async(this, null, function* () {
        var _a2, _b, _c, _d, _e;
        if (!import_node.H.isInitialized()) {
          import_node.H.init(options);
          import_node.H._debug("initialized H in apollo server");
        }
        const headers = {};
        (_b = (_a2 = req.request.http) == null ? void 0 : _a2.headers) == null ? void 0 : _b.forEach((v, k) => headers[k] = v);
        const { secureSessionId, requestId } = import_node.H.parseHeaders(headers);
        import_node.H.runWithHeaders(
          `${(_d = (_c = req.request.http) == null ? void 0 : _c.method) == null ? void 0 : _d.toUpperCase()} - ${(_e = req.request.http) == null ? void 0 : _e.search}`,
          headers,
          () => {
            import_node.H._debug("processError", "extracted from headers", {
              secureSessionId,
              requestId
            });
          }
        );
        return {
          didEncounterErrors(requestContext) {
            return __async(this, null, function* () {
              for (const error of requestContext.errors) {
                import_node.H.consumeError(error, secureSessionId, requestId);
                import_node.H._debug("consumed apollo request error", error);
              }
            });
          }
        };
      });
    }
  };
};

// src/apolloV3.ts
var import_node2 = require("@highlight-run/node");
var ApolloServerV3HighlightPlugin = function(options) {
  return {
    requestDidStart(req) {
      return __async(this, null, function* () {
        var _a2, _b, _c, _d, _e;
        if (!import_node2.H.isInitialized()) {
          import_node2.H.init(options);
          import_node2.H._debug("initialized H in apollo server");
        }
        const headers = {};
        for (const [k, v] of (_b = (_a2 = req.request.http) == null ? void 0 : _a2.headers) != null ? _b : []) {
          headers[k] = v;
        }
        const { secureSessionId, requestId } = import_node2.H.parseHeaders(headers);
        import_node2.H.runWithHeaders(
          `${(_d = (_c = req.request.http) == null ? void 0 : _c.method) == null ? void 0 : _d.toUpperCase()} - ${(_e = req.request.http) == null ? void 0 : _e.url}`,
          headers,
          () => {
            import_node2.H._debug("processError", "extracted from headers", {
              secureSessionId,
              requestId
            });
          }
        );
        return {
          didEncounterErrors(requestContext) {
            return __async(this, null, function* () {
              for (const error of requestContext.errors) {
                import_node2.H.consumeError(error, secureSessionId, requestId);
                import_node2.H._debug("consumed apollo request error", error);
              }
            });
          }
        };
      });
    }
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ApolloServerHighlightPlugin,
  ApolloServerV3HighlightPlugin
});
